Imports Microsoft.VisualStudio.TeamSystem.Data.DataGenerator
Imports System.IO

Public Class FileSourceGenerator : Inherits Generator
    Private _path As String             'Holds the path to the file with the data
    Private _currentRecord As Integer   'Pointer to the current record
    Private _values As List(Of String)  'Stores all of the values from the file

    <Input(Name:="File Path", Description:="Path to the file which contains the input values.")> _
    Public Property FilePath() As String
        Get
            Return _path
        End Get
        Set(ByVal value As String)
            _path = value
        End Set
    End Property

    Protected Overrides Sub OnInitialize(ByVal initInfo As Microsoft.VisualStudio.TeamSystem.Data.DataGenerator.GeneratorInit)
        _values = New List(Of String)()

        Dim fs As FileStream = New FileStream(_path, FileMode.Open, FileAccess.Read)
        Dim sr As StreamReader = New StreamReader(fs)

        While (Not sr.EndOfStream)
            _values.Add(sr.ReadLine())
        End While

        sr.Close()
    End Sub

    <Output(Name:="Result")> _
    Public ReadOnly Property Result() As String
        Get
            If (_currentRecord >= _values.Count) Then
                _currentRecord = 0
            End If
            Return _values(_currentRecord)
        End Get
    End Property

    Protected Overrides Sub OnGenerateNextValues()
        _currentRecord += 1
    End Sub

    Protected Overrides Sub OnValidateInputs()
        If (Not File.Exists(_path)) Then
            Throw New InputValidationException("The specified file does not exist.")
        End If
    End Sub
End Class