Imports System
Imports System.Collections.Generic
Imports System.Text
Imports Microsoft.VisualStudio.TeamSystem.Data.DataGenerator
Imports System.Data
Imports System.Data.SqlClient
Imports System.ComponentModel

<GeneratorStyles(DesignerStyles:=GeneratorDesignerStyles.None), _
Generator(GetType(SequentialGeneratorDesigner))> _
Public Class SequentialDataBoundGenerator : Inherits Generator

#Region "Private Members"
    Private _connectionInfo As String = ""
    Private _selectStatement As String = ""
    Private _ds As DataSet
    Private _currentRecord As Integer = 0
#End Region

#Region "Inputs"
    <Input(Name:="Select Statement")> _
    Public Property SelectStatement() As String
        Get
            Return _selectStatement
        End Get
        Set(ByVal value As String)
            _selectStatement = value
        End Set
    End Property

    <Input(EditorType:=GetType(System.Web.UI.Design.ConnectionStringEditor), TypeConverter:=GetType(StringConverter), Name:="Connection Info")> _
    Public Property ConnectionInfo() As String
        Get
            Return _connectionInfo
        End Get
        Set(ByVal value As String)
            _connectionInfo = value
        End Set
    End Property
#End Region

    Protected Overrides Sub OnGenerateNextValues()
        _currentRecord += 1
    End Sub

    Protected Overrides Function OnGetOutputValue() As Object
        Return _ds.Tables(0).Rows(_currentRecord)(StripBrackets(MyBase.OutputKey))
    End Function

    Protected Overrides Sub OnInitialize(ByVal initInfo As GeneratorInit)
        Dim cn As SqlConnection = New SqlConnection(_connectionInfo)
        Dim cmd As SqlCommand = New SqlCommand(_selectStatement, cn)
        Dim da As SqlDataAdapter = New SqlDataAdapter(cmd)
        _ds = New DataSet()
        da.Fill(_ds)
    End Sub

    Protected Overrides Sub OnValidateInputs()
        If _connectionInfo.Length = 0 Then
            Throw New InputValidationException("Connection Info must be supplied.")
        End If
        If _selectStatement.Length = 0 Then
            Throw New InputValidationException("Select statement must be supplied.")
        End If
    End Sub

    Private Function StripBrackets(ByVal column As String) As String
        Return column.Substring(1, column.Length - 2)
    End Function
End Class