Imports System.Collections.Generic
Imports Microsoft.VisualStudio.TeamSystem.Data.DataGenerator
Imports System.Data
Imports System.Data.SqlClient

Public Class SequentialGeneratorDesigner : Inherits DefaultGeneratorDesigner
    Private _cn As String                   'Holds the connection string
    Private _select As String               'Holds the select statement
    Private _cache As OutputDescriptor()    'Cache's the output

    ' <summary>
    ' Fired when one of the properties decorated an InputAttribute is changed
    ' </summary>
    Public Overrides Sub OnInputValueChanged(ByVal sender As Object, ByVal eventArgs As InputChangedEventArgs)
        If eventArgs.Input.Key = "ConnectionInfo" Then
            _cn = eventArgs.Input.Value.ToString()
        End If

        If eventArgs.Input.Key = "SelectStatement" Then
            _select = eventArgs.Input.Value.ToString()
        End If
    End Sub

    ''' <summary>
    ''' Called whenever the Output column of the Column Details window needs to 
    ''' be populated
    ''' </summary>
    ''' <returns>The list of columns from the select statement.</returns>
    Public Overrides Function GetOutputs() As Microsoft.VisualStudio.TeamSystem.Data.DataGenerator.OutputDescriptor()
        If (Not _cn Is Nothing) AndAlso (Not _select Is Nothing) Then
            Dim dt As DataTable = New DataTable()
            Dim cn As SqlConnection = New SqlConnection(_cn)
            Dim cmd As SqlCommand = New SqlCommand(_select, cn)
            Dim dr As SqlDataReader

            cn.Open()
            cmd.CommandType = CommandType.Text
            dr = cmd.ExecuteReader(CommandBehavior.SchemaOnly)
            dt = dr.GetSchemaTable()
            cn.Close()

            Dim od As List(Of OutputDescriptor) = New List(Of OutputDescriptor)()
            For i As Integer = 0 To dt.Rows.Count
                If dt.Rows(i).Table.Columns.Contains("ColumnName") Then
                    Dim desc As OutputDescriptor = New OutputDescriptor("[" & dt.Rows(i)("ColumnName").ToString() & "]", CType(dt.Columns(i).DataType, Type))
                    od.Add(desc)
                End If
            Next

            _cache = od.ToArray()
        End If

        Return _cache
    End Function
End Class